import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.sound.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Game extends PApplet {


SoundFile song;
Player player;
Map map;
UI ui;
Menu menu;
ArrayList<Slime> slimes = new ArrayList();
PImage winScreen, icon, loadingScreen;
PImage deathScreen[] = new PImage[2];
PImage numbers[] = new PImage[10];
boolean ingame, stageIsCleared, small, secondDeathScreen, isLoading=true, volumeUp, volumeDown;
int slimeCollected = 0, stage=1, value, gridPosX, gridPosY, winDelayTimer=0;
float volume=0.05f;
char slimeColor;

public void setup()
{
  
  frameRate(60);
  surface.setTitle("SpoonKnight");
  icon = loadImage("UI/SpoonKnightIcon.png");
  surface.setIcon(icon);
  loadingScreen = loadImage("Menu/HALLP.png");
  image(loadingScreen, 0, 0);
  thread("loading");
}

//Lädt Grafiken während Einblendung des Logos
public void loading()
{
  menu = new Menu();
  ui = new UI();
  player = new Player(120, 480);
  deathScreen[0] = loadImage("Menu/DeathScreen0.png");
  deathScreen[1] = loadImage("Menu/DeathScreen1.png");
  winScreen = loadImage("Menu/WinScreen.png");
  for (int i=0; i<numbers.length; i++)
  {
    numbers[i]=loadImage("Menu/"+i+".png");
  }
  song = new SoundFile(this, "Sound/Song0.wav");
  song.loop();
  isLoading=false;
}

//Zeichnet momentane Ebene, Winscreen, Deathscreen oder das Menu je nachdem was benötigt wird
public void draw()
{
  if (!isLoading)
  {
    soundManager();
    if (stageIsCleared)
    {
      ingame=false;
      image(winScreen, 0, 0);
      image(numbers[stage/10], -410, 760);
      image(numbers[stage%10], -340, 760);
      if (menu.enter)
      {
        menu.enter=false;
        stage++;
        map = new Map();
        stageIsCleared =false;
        player.x=120;
        player.y=480;
        player.blickR=true;
        for (int i=0; i<4; i++)
        {
          player.intersects[i]=false;
          player.wasd[i]=false;
          player.arrows[i]=false;
        }
        slimeRandomizer();
        ingame=true;
      }
    } else if (player.isDead)
    {
      ingame = false;
      image(deathScreen[0], 0, 0);
      if (menu.enter)
      {
        menu.enter=false;
        player.isDead=false;
        secondDeathScreen=true;
      }
    } else if (secondDeathScreen)
    {
      image(deathScreen[1], 0, 0);
      image(numbers[(stage-1)/10], 0, 0);
      image(numbers[(stage-1)%10], 70, 0);
      if (menu.enter)
      {
        menu.enter=false;
        stage=1;
        slimeCollected=0;
        slimes.clear();
        secondDeathScreen=false;
      }
    } else if (ingame)
    {
      background(166, 229, 103);
      map.update1();
      if (slimes.isEmpty())
      {
        winDelayTimer++;
        if(winDelayTimer>45)
        {
          winDelayTimer=0;
          stageIsCleared=true;
        }
      } else
      {
        for (int i=0; i<slimes.size(); i++)
        {
          slimes.get(i).update();
          if (slimes.get(i).isDead)
          {
            if (slimes.get(i).small&&slimeCollected<99)
            {
              slimeCollected++;
            }
            slimes.remove(i);
            slimes.trimToSize();
          }
        }
      }
      player.update();
      map.update2();
      ui.update();
    } else
    {
      menu.update();
    }
  }
}

//Für Regelung der Lautstärke
public void soundManager()
{
  if (volumeUp&&volume<1)
  {
    volume+=0.01f;
  }
  if (volumeDown&&volume>0)
  {
    volume-=0.01f;
  }
  song.amp(constrain(volume, 0, 1));
}

//Generiert zufällig Slimes
public void slimeRandomizer()
{
  for (int i=0; i<stage; i+=value)
  {
    value=(int)random(1, 7);
    gridPosX=(int)random(1, 12);
    gridPosY=(int)random(0, 5);
    if (i+value<=stage&&map.obstacleGrid[gridPosX][gridPosY]==0)
    {
      switch(value)
      {
      case 1:
        slimeColor='g';
        small=true;
        break;
      case 2:
        slimeColor='y';
        small=true;
        break;
      case 3:
        slimeColor='r';
        small=true;
        break;
      case 4:
        slimeColor='g';
        small=false;
        break;
      case 5:
        slimeColor='y';
        small=false;
        break;
      case 6:
        slimeColor='r';
        small=false;
        break;
      }
      slimes.add(new Slime((gridPosX+2)*120, (gridPosY+2)*120, slimeColor, small));
    } else
    {
      i-=value;
    }
  }
}

public void keyPressed()
{
  if (!isLoading)
  {
    if (ingame)
    {
      player.keyPressed();
    } else
    {
      menu.keyPressed();
    }

    if (key == '+') 
    {
      volumeUp = true;
    }
    if (key == '-') 
    {
      volumeDown = true;
    }
  }
}

public void keyReleased()
{
  if (!isLoading)
  {
    if (ingame)
    {
      player.keyReleased();
    } else
    {
      menu.keyReleased();
    }

    if (key == '+') 
    {
      volumeUp = false;
    }
    if (key == '-') 
    {
      volumeDown = false;
    }
  }
}
class Map
{
  PImage tree[] = new PImage[3];
  PImage trees[] = new PImage[76];
  PImage grass[] = new PImage[11];
  PImage passableObstacles[] = new PImage [7];
  PImage obstacles[] =new PImage[17];
  int grassGrid[][] = new int[16][9];
  int obstacleGrid[][] = new int[12][5];
  int passableObstacleGrid[][] = new int[14][7];
  int gridPosX, gridPosY;

  Map()
  {
    tree[0]=loadImage("Map/Tree0.png");
    tree[1]=loadImage("Map/Tree1.png");
    tree[2]=loadImage("Map/Tree2.png");
    treeRandomizer();

    for (int i=1; i<grass.length; i++)
    {
      grass[i]=loadImage("Map/ForegroundGrass"+i+".png");
    }
    grassRandomizer();

    for (int i=1; i<passableObstacles.length; i++)
    {
      passableObstacles[i]=loadImage("Map/PassableObstacle"+i+".png");
    }
    for (int i=1; i<obstacles.length; i++)
    {
      obstacles[i]=loadImage("Map/Obstacle"+i+".png");
    }
    obstacleRandomizer();
  }

  //Generiert zufällig Bäume
  public void treeRandomizer()
  {
    for (int i =0; i<76; i++)
    {
      trees[i]=tree[(int)random(0, 3)];
    }
  }

  //Generiert zufällig Grasbüschel
  public void grassRandomizer()
  {
    for (int i =0; i<((int)random(80, 140)); i++)
    {
      gridPosX=(int)random(0, 15);
      gridPosY=(int)random(0, 8);
      if (grassGrid[gridPosX][gridPosY]==0)
      {
        grassGrid[gridPosX][gridPosY]=(int)random(1, grass.length);
      } else
      {
        i--;
      }
    }
  }

  //Generiert zufällig Hindernisse
  public void obstacleRandomizer()
  {
    for (int i =0; i<((int)random(10, 15)); i++)
    {
      gridPosX=(int)random(0, 14);
      gridPosY=(int)random(0, 7);
      if (passableObstacleGrid[gridPosX][gridPosY]==0)
      {
        passableObstacleGrid[gridPosX][gridPosY]=(int)random(1, passableObstacles.length);
      } else
      {
        i--;
      }
    }

    for (int i =0; i<(int)random(5, 8); i++)
    {
      gridPosX=(int)random(0, 12);
      gridPosY=(int)random(0, 5);
      if (obstacleGrid[gridPosX][gridPosY]==0&&passableObstacleGrid[gridPosX+1][gridPosY+1]==0)
      {
        obstacleGrid[gridPosX][gridPosY]=(int)random(1, obstacles.length);
      } else
      {
        i--;
      }
    }
  }

  //Zeichnet die Grafiken die perspektivisch hinter dem Spieler angezeigt werden sollen
  public void update1()
  {
    for (int i=0; i<16; i++)
    {
      for (int j=0; j<9; j++)
      {
        if (grassGrid[i][j]!=0)
        {
          image(grass[grassGrid[i][j]], i*120, j*120, 120, 120);
        }
      }
    }

    for (int i=0; i<16; i++)
    {
      image(trees[i], i*120, -120, 120, 240);
      image(trees[i+16], i*120, 0, 120, 240);
    }

    for (int i=0; i<14; i++)
    {
      for (int j=0; j<7; j++)
      {
        if (passableObstacleGrid[i][j]!=0)
        {
          image(passableObstacles[passableObstacleGrid[i][j]], (i+1)*120, (j+1)*120, 120, 120);
        }
      }
    }

    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (obstacleGrid[i][j]!=0)
        {
          image(obstacles[obstacleGrid[i][j]], (i+2)*120, (j+2)*120, 120, 120);
        }
      }
    }
  }

  //Zeichnet die Grafiken die perspektivisch vor dem Spieler angezeigt werden sollen
  public void update2()
  {
    for (int i=0; i<7; i++)
    {
      image(trees[i+32], 0, i*120, 120, 240);
      image(trees[i+38], 1800, i*120, 120, 240);
    }
    for (int i=0; i<16; i++)
    {
      image(trees[i+54], i*120, 840, 120, 240);
      image(trees[i+60], i*120, 960, 120, 240);
    }
  }
}
class Menu
{
  PImage[] menu = new PImage[5];
  PImage[] controls = new PImage[2];
  PImage[] story = new PImage[11];
  boolean showMenu = true, showStory, up, down, enter;
  boolean[] showControls = new boolean[2];
  int spoonPosY = 215, menuTimer=100, storyCounter=0;
  float cloudPosition=-1100;

  Menu()
  {
    menu[0]=loadImage("Menu/MenuBackground.png");
    menu[1]=loadImage("Menu/MenuMovement.png");
    menu[2]=loadImage("Menu/MenuForeground.png");
    menu[3]=loadImage("Menu/MenuFont.png");
    menu[4]=loadImage("Menu/MenuSelection.png");
    controls[0]=loadImage("Menu/Controls0.png");
    controls[1]=loadImage("Menu/Controls1.png");
    for (int i=0; i<story.length; i++)
    {
      story[i]=loadImage("Menu/Story"+i+".png");
    }
  }

  public void update()
  {
    showMenu();
    actionPerformedMenu();
    movingClouds();
    menuTimer++;
  }

  //Bewegt die Wolken im Hintergrund
  public void movingClouds()
  {
    cloudPosition+=1;
    if (cloudPosition>=1920)
    {
      cloudPosition=-3840;
    }
  }

  //Zeigt das Menu
  public void showMenu() 
  {
    if (showMenu)
    {
      image(menu[0], 0, 0);
      image(menu[1], cloudPosition, 0);
      image(menu[2], 0, 0);
      image(menu[3], 0, 0);
      image(menu[4], -70, spoonPosY);
    } else if (showControls[0])
    {
      image(controls[0], 0, 0);
    } else if (showControls[1])
    {
      image(controls[1], 0, 0);
    } else if (showStory)
    {
      image(story[storyCounter], 0, 0);
    }
  }
  
  //Sorgt für Interaktionsmöglichkeiten im Menu
  public void actionPerformedMenu()
  {
    if (enter)
    {
      if (spoonPosY == 215)
      {
        ingame=true;
        enter=false;
        map = new Map();
        player = new Player(120, 480);
        slimes.add(new Slime(1680, 480, 'g', true));
      }

      if (spoonPosY == 325)
      {
        if (showStory)
        {
          if (storyCounter>9)
          {
            storyCounter=0;
            showStory=false;
            showMenu=true;
            enter=false;
          } else
          {
            storyCounter++;
            enter=false;
          }
        } else
        {
          showStory=true;
          showMenu=false;
          enter=false;
        }
      }

      if (showControls[1])
      {
        showMenu=true;
        showControls[1]=false;
        enter=false;
      } else if (showControls[0])
      { 
        showControls[1]=true;
        showControls[0]=false;
        enter=false;
      } else if (spoonPosY == 435)
      {
        showControls[0]=true;
        showMenu=false;
        enter=false;
      }

      if (spoonPosY == 545)
      {
        exit();
      }
    }

    if (menuTimer>15&&!showControls[0]&&!showControls[1]&&!showStory)
    {
      if (up && spoonPosY > 215) 
      {
        spoonPosY-=110;
        menuTimer=0;
      } else if (up && spoonPosY == 215)
      {
        spoonPosY=545;
        menuTimer=0;
      }

      if (down && spoonPosY < 545) 
      {
        spoonPosY+=110;
        menuTimer=0;
      } else if (down && spoonPosY == 545)
      {
        spoonPosY=215;
        menuTimer=0;
      }
    }
  }

  public void keyPressed() 
  {
    if (keyCode == UP || key == 'w') 
    {
      up = true;
    }
    if (keyCode == DOWN || key == 's') 
    {
      down = true;
    }
    if (key == '\n' || key == ' ') 
    {
      enter = true;
    }
  }

  public void keyReleased()
  {
    if (keyCode == UP || key == 'w') 
    {
      up = false;
    }
    if (keyCode == DOWN || key == 's') 
    {
      down = false;
    }
    if (key == '\n' || key == ' ') 
    {
      enter = false;
    }
  }
}
class Player
{
  PImage spoonknight;
  PImage projectile;
  PImage[] walk = new PImage[5];
  PImage[] attack = new PImage[4];
  PImage[] swoosh = new PImage[2];
  PImage[] swooshUp = new PImage[2];
  PImage[] swooshDown = new PImage[2];
  PImage[] dash = new PImage[9];
  PImage[] damage = new PImage[2];
  PImage[] death = new PImage[2];
  PImage[] heal = new PImage[9];
  PImage[] shoot = new PImage[4];
  PImage[] projectileHit = new PImage[6];
  PImage[] projectileHitUp = new PImage[6];
  PImage[] projectileHitDown = new PImage[6];
  // Die Boolean Arrays sind immer gegen den Uhrzeigersinn geordnet (orientiert daran, dass w, a, s, d normalerweise für oben, links, unten, rechts steht)
  boolean wasd[] = new boolean[4];
  boolean intersects[] = new boolean[4];
  boolean intersectsObstacle[][] = new boolean[10][4];
  boolean arrows[] = new boolean[4];
  boolean attackAnimation[] = new boolean[4];
  boolean shootAnimation[] = new boolean[4];
  boolean dashDirection[] = new boolean[4];
  boolean blickR=true, spacebar, isDead, projectileIsShot, shift;
  int timeSinceAttack=100, timeSinceDash=100, timeSinceDamaged=100, attackFrameCounter=0, timeSinceDeath=0, timeSinceHeal=100, timeSinceShoot=100, timeSinceProjectileHit=100;
  int health=6, projectileDirection=100;
  int obstaclePosX[] = new int[7];
  int obstaclePosY[] = new int[7];
  float x, y, w=120, h=120, projectileX=900, projectileY=120;

  Player(float x, float y)
  {
    this.x=x;
    this.y=y;
    spoonknight= loadImage("Spoonknight/Spoonknight.png");
    walk[0]= loadImage("Spoonknight/SpoonknightWalkcycle0.png");
    walk[1]= loadImage("Spoonknight/SpoonknightWalkcycle1.png");
    walk[2]= loadImage("Spoonknight/SpoonknightWalkcycle2.png");
    walk[3]= loadImage("Spoonknight/SpoonknightWalkcycle3.png");
    walk[4]= loadImage("Spoonknight/SpoonknightWalkcycle4.png");
    attack[0]= loadImage("Spoonknight/SpoonknightAttack0.png");
    attack[1]= loadImage("Spoonknight/SpoonknightAttack1.png");
    attack[2]= loadImage("Spoonknight/SpoonknightAttack2.png");
    attack[3]= loadImage("Spoonknight/SpoonknightAttack3.png");
    swoosh[0]= loadImage("Spoonknight/AttackField0.png");
    swoosh[1]= loadImage("Spoonknight/AttackField1.png");
    swooshUp[0]= loadImage("Spoonknight/AttackFieldUp0.png");
    swooshUp[1]= loadImage("Spoonknight/AttackFieldUp1.png");
    swooshDown[0]= loadImage("Spoonknight/AttackFieldDown0.png");
    swooshDown[1]= loadImage("Spoonknight/AttackFieldDown1.png");
    for (int i=0; i<dash.length; i++)
    {
      dash[i]=loadImage("Spoonknight/SpoonknightDash"+i+".png");
    }
    damage[0]= loadImage("Spoonknight/SpoonknightDamaged0.png");
    damage[1]= loadImage("Spoonknight/SpoonknightDamaged1.png");
    death[0]= loadImage("Spoonknight/SpoonknightDead0.png");
    death[1]= loadImage("Spoonknight/SpoonknightDead1.png");
    for (int i=0; i<heal.length; i++)
    {
      heal[i]=loadImage("Spoonknight/SpoonknightHealing"+i+".png");
    }
    projectile= loadImage("Spoonknight/Projectile.png");
    for (int i=0; i<shoot.length; i++)
    {
      shoot[i]=loadImage("Spoonknight/SpoonknightShoot"+i+".png");
    }
    for (int i=0; i<projectileHit.length; i++)
    {
      projectileHit[i]=loadImage("Spoonknight/ProjectileHit"+i+".png");
      projectileHitUp[i]=loadImage("Spoonknight/ProjectileHitUp"+i+".png");
      projectileHitDown[i]=loadImage("Spoonknight/ProjectileHitDown"+i+".png");
    }
  }

  public void update()
  {
    timer();
    move();
    attack();
    attackAnimation();
    intersects();
    dash();
    damageAnimation();
    deathAnimation();
    heal();
    shoot();
    shootAnimation();
    projectile();
  }

  //Verschiedene Timer für die Abklingzeiten des Spielers
  public void timer()
  {
    timeSinceAttack++;
    timeSinceDash++;
    timeSinceDamaged++;
    timeSinceHeal++;
    timeSinceProjectileHit++;
  }

  //Durch die Schussfähigkeit abgefeuertes Projektil
  public void projectile()
  {
    if (projectileIsShot)
    {
      image(projectile, projectileX, projectileY, w, h);
      switch(projectileDirection)
      {
      case 0:
        projectileY-=30;
        break;
      case 1:
        projectileX-=30;
        break;
      case 2:
        projectileY+=30;
        break;
      case 3:
        projectileX+=30;
        break;
      }
      for (int i=0; i<slimes.size(); i++)
      {
        if (projectileY-slimes.get(i).y>-60&&projectileY-slimes.get(i).y<60&&projectileX-slimes.get(i).x>-60&&projectileX-slimes.get(i).x<60)
        {
          slimes.get(i).getDamage(2);
          projectileIsShot=false;
          timeSinceProjectileHit=0;
        }
      }
      if (projectileX>1720||projectileX<80||projectileY>840||projectileY<120)
      {
        projectileIsShot=false;
        timeSinceProjectileHit=0;
      }
    }

    if (timeSinceProjectileHit<18)
    {
      switch(projectileDirection)
      {
      case 0:
        image(projectileHitUp[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      case 1:
        pushMatrix();
        scale(-1.0f, 1.0f);
        image(projectileHit[timeSinceProjectileHit/3], -projectileX-w, projectileY, w, h);
        popMatrix();
        break;
      case 2:
        image(projectileHitDown[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      case 3:
        image(projectileHit[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      }
    }
  }

  //Animation für den Schussangriff
  public void shootAnimation()
  {
    if (shootAnimation[0])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(shoot[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(shoot[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        attackFrameCounter++;
      } else
      {
        shootAnimation[0]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[1])
    {
      if (attackFrameCounter<12)
      {
        pushMatrix();
        scale(-1.0f, 1.0f);
        image(shoot[attackFrameCounter/3], -x-w, y, w, h);
        popMatrix();
        attackFrameCounter++;
      } else
      {
        shootAnimation[1]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[2])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(shoot[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(shoot[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        attackFrameCounter++;
      } else
      {
        shootAnimation[2]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[3])
    {
      if (attackFrameCounter<12)
      {
        image(shoot[attackFrameCounter/3], x, y, w, h);
        attackFrameCounter++;
      } else
      {
        shootAnimation[3]=false;
        attackFrameCounter=0;
      }
    }
  }
  
  //Schussangriff
  public void shoot()
  {
    if (shift&&timeSinceAttack>60&&timeSinceDash>60&&health>0&&slimeCollected>=1)
    {
      for (int i=0; i<arrows.length; i++)
      {
        if (arrows[i])
        {
          timeSinceAttack=0;
          projectileX=x;
          projectileY=y;
          projectileIsShot=true;
          shootAnimation[i]=true;
          projectileDirection=i;
          slimeCollected--;
        }
      }
    }
  }
  
  //Heilungsfähigkeit mit Animation
  public void heal()
  {
    if (health>0&&timeSinceDash>24&&timeSinceDamaged>30&&timeSinceAttack>12)
    {
      if (key=='e'&&slimeCollected>=10&&timeSinceHeal>=120&&health<6)
      {
        slimeCollected-=10;
        health+=2;
        if (health>6)
        {
          health=6;
        }
        timeSinceHeal=0;
      }

      if (timeSinceHeal<27)
      {
        if (blickR)
        {
          image(heal[timeSinceHeal/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(heal[timeSinceHeal/3], -x-w, y, w, h);
          popMatrix();
        }
      }
    }
  }

  //Animation die bei Tod des Spielers angezeigt wird
  public void deathAnimation()
  {
    if (timeSinceDeath>=120)
    {
      isDead=true;
      timeSinceDeath=0;
    } else if (health<=0&&timeSinceDamaged>30)
    {
      image(death[timeSinceDeath/12%2], x, y, w, h);
      timeSinceDeath++;
    }
  }

  //Lebensverringerung und Rückstoss bei Gegnerkollision
  public void takeDamage(int damageDirection)
  {
    if (timeSinceDash>24)
    {
      if (timeSinceDamaged>30&&health>0)
      {
        health--;
        timeSinceDamaged=0;
      } else
      {
        switch(damageDirection)
        {
        case 0:
          if (!intersects[2])
          {
            y+=20;
          } 
          break;

        case 1:
          if (!intersects[3])
          {
            x+=20;
          } 
          break;

        case 2:
          if (!intersects[0])
          {
            y-=20;
          } 
          break;

        case 3:
          if (!intersects[1])
          {
            x-=20;
          }
          break;
        }
      }
    }
  }
  
  //Animation bei Gegnerkollision
  public void damageAnimation()
  {
    if (timeSinceDamaged<=30)
    {
      if (blickR)
      {
        image(damage[frameCount/3%2], x, y, w, h);
      } else
      {
        pushMatrix();
        scale(-1.0f, 1.0f);
        image(damage[frameCount/3%2], -x-w, y, w, h);
        popMatrix();
      }
    }
  }
  
  //Animation und rapide Fortbewegung bei Einsatz der Dash-Fähigkeit
  public void dash()
  {
    if (timeSinceDash>180&&health>0)
    {
      if (spacebar)
      {
        timeSinceDash=0;
        if (wasd[0])
        {
          dashDirection[0]=true;
        } else if (wasd[1])
        {
          dashDirection[1]=true;
        } else if (wasd[2]==true)
        {
          dashDirection[2]=true;
        } else if (wasd[3])
        {
          dashDirection[3]=true;
        } else
        {
          if (!blickR)
          {
            dashDirection[1]=true;
          } else
          {
            dashDirection[3]=true;
          }
        }
      }
    }

    if (timeSinceDash<=24)
    {
      if (blickR)
      {
        image(dash[timeSinceDash/3], x, y, w, h);
      } else
      {
        pushMatrix();
        scale(-1.0f, 1.0f);
        image(dash[timeSinceDash/3], -x-w, y, w, h);
        popMatrix();
      }

      if (!intersects[0]) 
      {
        if (dashDirection[0])
        {
          y=y-15;
        }
      }
      if (!intersects[1])  
      {
        if (dashDirection[1])
        {
          x=x-15;
        }
      }
      if (!intersects[2]) 
      {
        if (dashDirection[2])
        {
          y=y+15;
        }
      }
      if (!intersects[3])  
      {
        if (dashDirection[3])
        {
          x=x+15;
        }
      }
    } else
    {
      dashDirection[0]=false;
      dashDirection[1]=false;
      dashDirection[2]=false;
      dashDirection[3]=false;
    }
  }

  //Animation des Angriffs
  public void attackAnimation()
  {
    if (attackAnimation[0])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(attack[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(attack[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        image(swooshUp[attackFrameCounter/6], x, y-120, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[0]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[1])
    {
      if (attackFrameCounter<12)
      {
        pushMatrix();
        scale(-1.0f, 1.0f);
        image(attack[attackFrameCounter/3], -x-w, y, w, h);
        image(swoosh[attackFrameCounter/6], -x, y, w, h);
        popMatrix();
        attackFrameCounter++;
      } else
      {
        attackAnimation[1]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[2])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(attack[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(attack[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        image(swooshDown[attackFrameCounter/6], x, y+120, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[2]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[3])
    {
      if (attackFrameCounter<12)
      {
        image(attack[attackFrameCounter/3], x, y, w, h);
        image(swoosh[attackFrameCounter/6], x+120, y, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[3]=false;
        attackFrameCounter=0;
      }
    }
  }

  //Angriff der Gegnern bei Treffer Schaden zufügt
  public void attack()
  {
    if (!shift&&timeSinceAttack>60&&timeSinceDash>60&&health>0)
    {
      if (arrows[0])
      {
        attackAnimation[0]=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (y-120-slimes.get(i).y>-90&&y-120-slimes.get(i).y<90&&x-slimes.get(i).x>-90&&x-slimes.get(i).x<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[1])
      {
        attackAnimation[1]=true;
        blickR=false;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (x-120-slimes.get(i).x>-90&&x-120-slimes.get(i).x<90&&y-slimes.get(i).y>-90&&y-slimes.get(i).y<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[2])
      {
        attackAnimation[2]=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (y+120-slimes.get(i).y>-90&&y+120-slimes.get(i).y<90&&x-slimes.get(i).x>-90&&x-slimes.get(i).x<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[3])
      {
        attackAnimation[3]=true;
        blickR=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (x+120-slimes.get(i).x>-90&&x+120-slimes.get(i).x<90&&y-slimes.get(i).y>-90&&y-slimes.get(i).y<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      }
    }
  }
  
  //Prüft auf Kollisionen
  public void intersects()
  {
    int obstacleCounter=0;
    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (map.obstacleGrid[i][j]!=0)
        {
          obstaclePosX[obstacleCounter]=(i+2)*120;
          obstaclePosY[obstacleCounter]=(j+2)*120;
          obstacleCounter++;
        }
      }
    }

    for (int i=0; i<obstacleCounter; i++)
    {
      if (y-obstaclePosY[i]<=75&&y-obstaclePosY[i]>0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][0]=true;
      } else
      {
        intersectsObstacle[i][0]=false;
      }

      if (x-obstaclePosX[i]<=105&&x-obstaclePosX[i]>0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][1]=true;
      } else
      {
        intersectsObstacle[i][1]=false;
      }

      if (y-obstaclePosY[i]>=-120 &&y-obstaclePosY[i]<0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][2]=true;
      } else
      {
        intersectsObstacle[i][2]=false;
      }

      if (x-obstaclePosX[i]>=-105 &&x-obstaclePosX[i]<0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][3]=true;
      } else
      {
        intersectsObstacle[i][3]=false;
      }
    }

    for (int i=0; i<4; i++)
    {
      if (intersectsObstacle[0][i]||intersectsObstacle[1][i]||intersectsObstacle[2][i]||intersectsObstacle[3][i]||intersectsObstacle[4][i]||intersectsObstacle[5][i]||intersectsObstacle[6][i])
      {
        intersects[i]=true;
      } else
      {
        intersects[i]=false;
      }
    }
    if (y <= 120) 
    {
      intersects[0] = true;
    } 
    
    if (x <= 105) 
    {
      intersects[1] = true;
    }

    if (y >= 840) 
    {
      intersects[2] = true;
    } 

    if (x >= 1695) 
    {
      intersects[3] = true;
    }
  }

  //Bewegung des Spielers durch wasd mit Animation
  public void move()
  {
    if (timeSinceAttack>=12&&timeSinceDash>24&&timeSinceHeal>=27)
    {
      if (!intersects[0]) 
      {
        if (wasd[0]==true)
        {
          y=y-5;
        }
      }
      if (!intersects[1])  
      {
        if (wasd[1]==true)
        {
          x=x-5;
          blickR=false;
        }
      }
      if (!intersects[2]) 
      {
        if (wasd[2]==true)
        {
          y=y+5;
        }
      }
      if (!intersects[3])  
      {
        if (wasd[3]==true)
        {
          x=x+5;
          blickR=true;
        }
      }

      if (timeSinceDamaged>30)
      {
        if (wasd[0]==true||wasd[1]==true||wasd[2]==true||wasd[3]==true)
        {
          if (blickR)
          {
            image(walk[frameCount/6%5], x, y, w, h);
          } else
          {
            pushMatrix();
            scale(-1.0f, 1.0f);
            image(walk[frameCount/6%5], -x-w, y, w, h);
            popMatrix();
          }
        } else if (blickR)
        {
          image(spoonknight, x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0f, 1.0f);
          image(spoonknight, -x-w, y, w, h);
          popMatrix();
        }
      }
    }
  }

  public void keyPressed()
  {
    if (health>0&&timeSinceHeal>=27)
    {
      if (key =='w')
      {
        wasd[0]=true;
      }
      if (key =='a')
      {
        wasd[1]=true;
      }
      if (key =='s')
      {
        wasd[2]=true;
      }
      if (key =='d')
      {
        wasd[3]=true;
      }
      if (key ==' ')
      {
        spacebar=true;
      }
      if (keyCode == UP)
      {
        arrows[0]=true;
      }
      if (keyCode == LEFT)
      {
        arrows[1]=true;
      }
      if (keyCode == DOWN)
      {
        arrows[2]=true;
      }
      if (keyCode == RIGHT)
      {
        arrows[3]=true;
      }
      if (keyCode == SHIFT)
      {
        shift=true;
      }
    }
  }

  public void keyReleased()
  {
    if (key =='w')
    {
      wasd[0]=false;
    }
    if (key =='a')
    {
      wasd[1]=false;
    }
    if (key =='s')
    {
      wasd[2]=false;
    }
    if (key =='d')
    {
      wasd[3]=false;
    }
    if (key ==' ')
    {
      spacebar=false;
    }
    if (keyCode == UP)
    {
      arrows[0]=false;
    }
    if (keyCode == LEFT)
    {
      arrows[1]=false;
    }
    if (keyCode == DOWN)
    {
      arrows[2]=false;
    }
    if (keyCode == RIGHT)
    {
      arrows[3]=false;
    }
    if (keyCode == SHIFT)
    {
      shift=false;
    }
  }
}
class Slime
{
  PImage[] death = new PImage[6];
  PImage[] jump = new PImage[8];
  PImage[] damage = new PImage[2];
  boolean intersects[] = new boolean[4];
  boolean intersectsObstacle[][] = new boolean[7][4];
  boolean isDead, small;
  int direction, timeSinceDamaged=100, timeSinceDeath=0, health=4, jumpDelay, directionRandomizer, frameCounter=24;
  int obstaclePosX[] = new int[7];
  int obstaclePosY[] = new int[7];
  float x, y, w=120, h=120, hitboxReduction=0, distancePlayerX, distancePlayerY;
  char slimeColor;
  String size = "";

  Slime(float x, float y, char slimeColor, boolean small)
  {
    this.x=x;
    this.y=y;
    this.slimeColor=slimeColor;
    this.small = small;

    if (small)
    {
      health=2;
      hitboxReduction=15;
      size="Small";
    }

    for (int i=0; i<jump.length; i++)
    {
      jump[i]=loadImage("Enemies/"+slimeColor+size+"SlimeJump"+i+".png");
    }
    damage[0]= loadImage("Enemies/"+slimeColor+size+"SlimeDamaged0.png");
    damage[1]= loadImage("Enemies/"+slimeColor+size+"SlimeDamaged1.png");
    for (int i=0; i<death.length; i++)
    {
      death[i]=loadImage("Enemies/"+slimeColor+size+"SlimeDead"+i+".png");
    }

    //Die verschiedenen Slimefarben sollen sich in unterschiedlicher Frequenz bewegen
    switch(slimeColor)
    {
    case 'g':
      jumpDelay=144;
      break;
    case 'y':
      jumpDelay=96;
      break;
    case 'r':
      jumpDelay=48;
      break;
    }
  }

  public void update()
  {
    intersects();
    move();
    applyDamage();
    death();
    damageAnimation();
    timeSinceDamaged++;
    frameCounter++;
  }

  //Regelmäßige Fortbewegung des Slimes mit Sprunganimation
  public void move()
  {
    if (health>0||x%120!=0||y%120!=0)
    {
      if (timeSinceDamaged>30)
      {
        image(jump[frameCounter/6%8], x, y, w, h);
      }

      directionCalculation();

      if (frameCounter%jumpDelay<24)
      {
        switch(direction)
        {
        case 0:
          y=y-5;
          break;
        case 1: 
          x=x-5;
          break;
        case 2: 
          y=y+5;
          break;
        case 3: 
          x=x+5;
          break;
        case 4:
        }
      }
    }
  }

  //Kalkulation der nächsten Bewegung (Zu 70% Bewegung in Richtung des Spielers, zu 20% Bewegung in zufällige Richtung, zu 10% ausharren auf momentaner Position) 
  public void  directionCalculation()
  {
    if (frameCounter%jumpDelay==0)
    {
      distancePlayerX=player.x-x;
      distancePlayerY=player.y-y;
      directionRandomizer=(int)random(0, 10);

      if (directionRandomizer<7)
      {
        if (Math.abs(distancePlayerX)<Math.abs(distancePlayerY))
        {
          if (distancePlayerY<0&&!intersects[0])
          {
            direction=0;
          } else if (distancePlayerY>0&&!intersects[2])
          {
            direction=2;
          } else if (distancePlayerX<0&&!intersects[1])
          {
            direction=1;
          } else if (distancePlayerX>0&&!intersects[3])
          {
            direction=3;
          } else
          {
            direction=4;
          }
        } else
        {
          if (distancePlayerX<0&&!intersects[1])
          {
            direction=1;
          } else if (distancePlayerX>0&&!intersects[3])
          {
            direction=3;
          } else if (distancePlayerY<0&&!intersects[0])
          {
            direction=0;
          } else if (distancePlayerY>0&&!intersects[2])
          {
            direction=2;
          } else
          {
            direction=4;
          }
        }
      } else if (directionRandomizer<9)
      {
        do
        {
          direction=(int)random(0, 4);
        }
        while (intersects[direction]);
      } else if (directionRandomizer==9)
      {
        direction=4;
      }
    }
  }

  //Lässt den Slime mit Animation verschwinden wenn er keine Lebenspunkte mehr hat und teilt große Slimes in 2 kleine Slimes auf
  public void death()
  {
    if (health<=0&&timeSinceDamaged>30)
    {
      image(death[timeSinceDeath/6], x, y, w, h);
      timeSinceDeath++;
    }

    if (timeSinceDeath==10&&!small)
    {
      slimes.add(new Slime(x, y, slimeColor, true));
      slimes.add(new Slime(x, y, slimeColor, true));
    }

    if (timeSinceDeath>=33)
    {
      isDead=true;
    }
  }

  //Animation bei Schaden
  public void damageAnimation()
  {
    if (health>=0)
    {
      if (timeSinceDamaged<30)
      {
        image(damage[frameCounter/6%2], x, y, w, h);
      }
    }
  }

  //Schaden bei Attackentreffer durch Spieler
  public void getDamage(int damage)
  {
    health-=damage;
    timeSinceDamaged=0;
  }

  //Fügt Spieler bei Berührung Schaden zu
  public void applyDamage()
  {
    if (y-player.y>=-60&&y-player.y<0&&x-player.x>=-60&&x-player.x<=60)
    {
      player.takeDamage(0);
    }
    if (x-player.x>=-90+hitboxReduction&&x-player.x<0&&y-player.y>=-60&&y-player.y<=60)
    {
      player.takeDamage(1);
    }
    if (y-player.y<=90-hitboxReduction&&y-player.y>0&&x-player.x>=-60&&x-player.x<=60)
    {
      player.takeDamage(2);
    }
    if (x-player.x<=90-hitboxReduction&&x-player.x>0&&y-player.y>=-60&&y-player.y<=60)
    {
      player.takeDamage(3);
    }
  }

  //Prüft auf Kollisionen
  public void intersects()
  {
    int obstacleCounter=0;
    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (map.obstacleGrid[i][j]!=0)
        {
          obstaclePosX[obstacleCounter]=(i+2)*120;
          obstaclePosY[obstacleCounter]=(j+2)*120;
          obstacleCounter++;
        }
      }
    }

    for (int i=0; i<obstacleCounter; i++)
    {
      if (y-obstaclePosY[i]<=120&&y-obstaclePosY[i]>0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][0]=true;
      } else
      {
        intersectsObstacle[i][0]=false;
      }

      if (x-obstaclePosX[i]<=120&&x-obstaclePosX[i]>0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][1]=true;
      } else
      {
        intersectsObstacle[i][1]=false;
      }

      if (y-obstaclePosY[i]>=-120 &&y-obstaclePosY[i]<0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][2]=true;
      } else
      {
        intersectsObstacle[i][2]=false;
      }

      if (x-obstaclePosX[i]>=-120 &&x-obstaclePosX[i]<0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][3]=true;
      } else
      {
        intersectsObstacle[i][3]=false;
      }
    }

    for (int i=0; i<4; i++)
    {
      if (intersectsObstacle[0][i]||intersectsObstacle[1][i]||intersectsObstacle[2][i]||intersectsObstacle[3][i]||intersectsObstacle[4][i]||intersectsObstacle[5][i]||intersectsObstacle[6][i])
      {
        intersects[i]=true;
      } else
      {
        intersects[i]=false;
      }
    }
    if (y <= 120) 
    {
      intersects[0] = true;
    } 
    if (x <= 120) 
    {
      intersects[1] = true;
    }

    if (y >= 840) 
    {
      intersects[2] = true;
    } 

    if (x >= 1680) 
    {
      intersects[3] = true;
    }
  }
}
class UI
{
  PImage[] hearts = new PImage[3];
  PImage[] numbers = new PImage[10];
  PImage quantityIndicator, slimeCollectedSymbol;

  UI()
  {
    hearts[0]=loadImage("UI/HeartEmpty.png");
    hearts[1]=loadImage("UI/HeartHalf.png");
    hearts[2]=loadImage("UI/HeartFull.png");
    for (int i=0; i<numbers.length; i++)
    {
      numbers[i] = loadImage("UI/"+i+".png");
    }
    quantityIndicator = loadImage("UI/Quantity.png");
    slimeCollectedSymbol = loadImage("UI/SlimeCount.png");
  }

  public void update()
  {
    healthDisplay();
    slimeCollectedDisplay();
  }

  //Lebensanzeige
  public void healthDisplay()
  {
    switch(player.health)
    {
    case 1:
      image(hearts[1], 0, 0, 120, 120);
      image(hearts[0], 120, 0, 120, 120);
      image(hearts[0], 240, 0, 120, 120);
      break;
    case 2:
      image(hearts[2], 0, 0, 120, 120);
      image(hearts[0], 120, 0, 120, 120);
      image(hearts[0], 240, 0, 120, 120);
      break;
    case 3:
      image(hearts[2], 0, 0, 120, 120);
      image(hearts[1], 120, 0, 120, 120);
      image(hearts[0], 240, 0, 120, 120);
      break;
    case 4:
      image(hearts[2], 0, 0, 120, 120);
      image(hearts[2], 120, 0, 120, 120);
      image(hearts[0], 240, 0, 120, 120);
      break;
    case 5:
      image(hearts[2], 0, 0, 120, 120);
      image(hearts[2], 120, 0, 120, 120);
      image(hearts[1], 240, 0, 120, 120);
      break;
    case 6:
      image(hearts[2], 0, 0, 120, 120);
      image(hearts[2], 120, 0, 120, 120);
      image(hearts[2], 240, 0, 120, 120);
      break;
    default:
      image(hearts[0], 0, 0, 120, 120);
      image(hearts[0], 120, 0, 120, 120);
      image(hearts[0], 240, 0, 120, 120);
    }
  }
  
  //Anzeige der gesammelten Slimes
  public void slimeCollectedDisplay()
  {
    image(numbers[slimeCollected/10], 1562, 0);
    image(numbers[slimeCollected%10], 1622, 0);
    image(quantityIndicator, 1670, 0);
    image(slimeCollectedSymbol, 1782, 0);
  }
}
  public void settings() {  size(1920, 1080); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Game" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
