import processing.sound.*;
SoundFile song;
Player player;
Map map;
UI ui;
Menu menu;
ArrayList<Slime> slimes = new ArrayList();
PImage winScreen, icon, loadingScreen;
PImage deathScreen[] = new PImage[2];
PImage numbers[] = new PImage[10];
boolean ingame, stageIsCleared, small, secondDeathScreen, isLoading=true, volumeUp, volumeDown;
int slimeCollected = 0, stage=1, value, gridPosX, gridPosY, winDelayTimer=0;
float volume=0.05;
char slimeColor;

void setup()
{
  size(1920, 1080);
  frameRate(60);
  surface.setTitle("SpoonKnight");
  icon = loadImage("UI/SpoonKnightIcon.png");
  surface.setIcon(icon);
  loadingScreen = loadImage("Menu/HALLP.png");
  image(loadingScreen, 0, 0);
  thread("loading");
}

//Lädt Grafiken während Einblendung des Logos
void loading()
{
  menu = new Menu();
  ui = new UI();
  player = new Player(120, 480);
  deathScreen[0] = loadImage("Menu/DeathScreen0.png");
  deathScreen[1] = loadImage("Menu/DeathScreen1.png");
  winScreen = loadImage("Menu/WinScreen.png");
  for (int i=0; i<numbers.length; i++)
  {
    numbers[i]=loadImage("Menu/"+i+".png");
  }
  song = new SoundFile(this, "Sound/Song0.wav");
  song.loop();
  isLoading=false;
}

//Zeichnet momentane Ebene, Winscreen, Deathscreen oder das Menu je nachdem was benötigt wird
void draw()
{
  if (!isLoading)
  {
    soundManager();
    if (stageIsCleared)
    {
      ingame=false;
      image(winScreen, 0, 0);
      image(numbers[stage/10], -410, 760);
      image(numbers[stage%10], -340, 760);
      if (menu.enter)
      {
        menu.enter=false;
        stage++;
        map = new Map();
        stageIsCleared =false;
        player.x=120;
        player.y=480;
        player.blickR=true;
        for (int i=0; i<4; i++)
        {
          player.intersects[i]=false;
          player.wasd[i]=false;
          player.arrows[i]=false;
        }
        slimeRandomizer();
        ingame=true;
      }
    } else if (player.isDead)
    {
      ingame = false;
      image(deathScreen[0], 0, 0);
      if (menu.enter)
      {
        menu.enter=false;
        player.isDead=false;
        secondDeathScreen=true;
      }
    } else if (secondDeathScreen)
    {
      image(deathScreen[1], 0, 0);
      image(numbers[(stage-1)/10], 0, 0);
      image(numbers[(stage-1)%10], 70, 0);
      if (menu.enter)
      {
        menu.enter=false;
        stage=1;
        slimeCollected=0;
        slimes.clear();
        secondDeathScreen=false;
      }
    } else if (ingame)
    {
      background(166, 229, 103);
      map.update1();
      if (slimes.isEmpty())
      {
        winDelayTimer++;
        if(winDelayTimer>45)
        {
          winDelayTimer=0;
          stageIsCleared=true;
        }
      } else
      {
        for (int i=0; i<slimes.size(); i++)
        {
          slimes.get(i).update();
          if (slimes.get(i).isDead)
          {
            if (slimes.get(i).small&&slimeCollected<99)
            {
              slimeCollected++;
            }
            slimes.remove(i);
            slimes.trimToSize();
          }
        }
      }
      player.update();
      map.update2();
      ui.update();
    } else
    {
      menu.update();
    }
  }
}

//Für Regelung der Lautstärke
void soundManager()
{
  if (volumeUp&&volume<1)
  {
    volume+=0.01;
  }
  if (volumeDown&&volume>0)
  {
    volume-=0.01;
  }
  song.amp(constrain(volume, 0, 1));
}

//Generiert zufällig Slimes
void slimeRandomizer()
{
  for (int i=0; i<stage; i+=value)
  {
    value=(int)random(1, 7);
    gridPosX=(int)random(1, 12);
    gridPosY=(int)random(0, 5);
    if (i+value<=stage&&map.obstacleGrid[gridPosX][gridPosY]==0)
    {
      switch(value)
      {
      case 1:
        slimeColor='g';
        small=true;
        break;
      case 2:
        slimeColor='y';
        small=true;
        break;
      case 3:
        slimeColor='r';
        small=true;
        break;
      case 4:
        slimeColor='g';
        small=false;
        break;
      case 5:
        slimeColor='y';
        small=false;
        break;
      case 6:
        slimeColor='r';
        small=false;
        break;
      }
      slimes.add(new Slime((gridPosX+2)*120, (gridPosY+2)*120, slimeColor, small));
    } else
    {
      i-=value;
    }
  }
}

void keyPressed()
{
  if (!isLoading)
  {
    if (ingame)
    {
      player.keyPressed();
    } else
    {
      menu.keyPressed();
    }

    if (key == '+') 
    {
      volumeUp = true;
    }
    if (key == '-') 
    {
      volumeDown = true;
    }
  }
}

void keyReleased()
{
  if (!isLoading)
  {
    if (ingame)
    {
      player.keyReleased();
    } else
    {
      menu.keyReleased();
    }

    if (key == '+') 
    {
      volumeUp = false;
    }
    if (key == '-') 
    {
      volumeDown = false;
    }
  }
}
