class Map
{
  PImage tree[] = new PImage[3];
  PImage trees[] = new PImage[76];
  PImage grass[] = new PImage[11];
  PImage passableObstacles[] = new PImage [7];
  PImage obstacles[] =new PImage[17];
  int grassGrid[][] = new int[16][9];
  int obstacleGrid[][] = new int[12][5];
  int passableObstacleGrid[][] = new int[14][7];
  int gridPosX, gridPosY;

  Map()
  {
    tree[0]=loadImage("Map/Tree0.png");
    tree[1]=loadImage("Map/Tree1.png");
    tree[2]=loadImage("Map/Tree2.png");
    treeRandomizer();

    for (int i=1; i<grass.length; i++)
    {
      grass[i]=loadImage("Map/ForegroundGrass"+i+".png");
    }
    grassRandomizer();

    for (int i=1; i<passableObstacles.length; i++)
    {
      passableObstacles[i]=loadImage("Map/PassableObstacle"+i+".png");
    }
    for (int i=1; i<obstacles.length; i++)
    {
      obstacles[i]=loadImage("Map/Obstacle"+i+".png");
    }
    obstacleRandomizer();
  }

  //Generiert zufällig Bäume
  void treeRandomizer()
  {
    for (int i =0; i<76; i++)
    {
      trees[i]=tree[(int)random(0, 3)];
    }
  }

  //Generiert zufällig Grasbüschel
  void grassRandomizer()
  {
    for (int i =0; i<((int)random(80, 140)); i++)
    {
      gridPosX=(int)random(0, 15);
      gridPosY=(int)random(0, 8);
      if (grassGrid[gridPosX][gridPosY]==0)
      {
        grassGrid[gridPosX][gridPosY]=(int)random(1, grass.length);
      } else
      {
        i--;
      }
    }
  }

  //Generiert zufällig Hindernisse
  void obstacleRandomizer()
  {
    for (int i =0; i<((int)random(10, 15)); i++)
    {
      gridPosX=(int)random(0, 14);
      gridPosY=(int)random(0, 7);
      if (passableObstacleGrid[gridPosX][gridPosY]==0)
      {
        passableObstacleGrid[gridPosX][gridPosY]=(int)random(1, passableObstacles.length);
      } else
      {
        i--;
      }
    }

    for (int i =0; i<(int)random(5, 8); i++)
    {
      gridPosX=(int)random(0, 12);
      gridPosY=(int)random(0, 5);
      if (obstacleGrid[gridPosX][gridPosY]==0&&passableObstacleGrid[gridPosX+1][gridPosY+1]==0)
      {
        obstacleGrid[gridPosX][gridPosY]=(int)random(1, obstacles.length);
      } else
      {
        i--;
      }
    }
  }

  //Zeichnet die Grafiken die perspektivisch hinter dem Spieler angezeigt werden sollen
  void update1()
  {
    for (int i=0; i<16; i++)
    {
      for (int j=0; j<9; j++)
      {
        if (grassGrid[i][j]!=0)
        {
          image(grass[grassGrid[i][j]], i*120, j*120, 120, 120);
        }
      }
    }

    for (int i=0; i<16; i++)
    {
      image(trees[i], i*120, -120, 120, 240);
      image(trees[i+16], i*120, 0, 120, 240);
    }

    for (int i=0; i<14; i++)
    {
      for (int j=0; j<7; j++)
      {
        if (passableObstacleGrid[i][j]!=0)
        {
          image(passableObstacles[passableObstacleGrid[i][j]], (i+1)*120, (j+1)*120, 120, 120);
        }
      }
    }

    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (obstacleGrid[i][j]!=0)
        {
          image(obstacles[obstacleGrid[i][j]], (i+2)*120, (j+2)*120, 120, 120);
        }
      }
    }
  }

  //Zeichnet die Grafiken die perspektivisch vor dem Spieler angezeigt werden sollen
  void update2()
  {
    for (int i=0; i<7; i++)
    {
      image(trees[i+32], 0, i*120, 120, 240);
      image(trees[i+38], 1800, i*120, 120, 240);
    }
    for (int i=0; i<16; i++)
    {
      image(trees[i+54], i*120, 840, 120, 240);
      image(trees[i+60], i*120, 960, 120, 240);
    }
  }
}
