class Menu
{
  PImage[] menu = new PImage[5];
  PImage[] controls = new PImage[2];
  PImage[] story = new PImage[11];
  boolean showMenu = true, showStory, up, down, enter;
  boolean[] showControls = new boolean[2];
  int spoonPosY = 215, menuTimer=100, storyCounter=0;
  float cloudPosition=-1100;

  Menu()
  {
    menu[0]=loadImage("Menu/MenuBackground.png");
    menu[1]=loadImage("Menu/MenuMovement.png");
    menu[2]=loadImage("Menu/MenuForeground.png");
    menu[3]=loadImage("Menu/MenuFont.png");
    menu[4]=loadImage("Menu/MenuSelection.png");
    controls[0]=loadImage("Menu/Controls0.png");
    controls[1]=loadImage("Menu/Controls1.png");
    for (int i=0; i<story.length; i++)
    {
      story[i]=loadImage("Menu/Story"+i+".png");
    }
  }

  void update()
  {
    showMenu();
    actionPerformedMenu();
    movingClouds();
    menuTimer++;
  }

  //Bewegt die Wolken im Hintergrund
  void movingClouds()
  {
    cloudPosition+=1;
    if (cloudPosition>=1920)
    {
      cloudPosition=-3840;
    }
  }

  //Zeigt das Menu
  void showMenu() 
  {
    if (showMenu)
    {
      image(menu[0], 0, 0);
      image(menu[1], cloudPosition, 0);
      image(menu[2], 0, 0);
      image(menu[3], 0, 0);
      image(menu[4], -70, spoonPosY);
    } else if (showControls[0])
    {
      image(controls[0], 0, 0);
    } else if (showControls[1])
    {
      image(controls[1], 0, 0);
    } else if (showStory)
    {
      image(story[storyCounter], 0, 0);
    }
  }
  
  //Sorgt für Interaktionsmöglichkeiten im Menu
  void actionPerformedMenu()
  {
    if (enter)
    {
      if (spoonPosY == 215)
      {
        ingame=true;
        enter=false;
        map = new Map();
        player = new Player(120, 480);
        slimes.add(new Slime(1680, 480, 'g', true));
      }

      if (spoonPosY == 325)
      {
        if (showStory)
        {
          if (storyCounter>9)
          {
            storyCounter=0;
            showStory=false;
            showMenu=true;
            enter=false;
          } else
          {
            storyCounter++;
            enter=false;
          }
        } else
        {
          showStory=true;
          showMenu=false;
          enter=false;
        }
      }

      if (showControls[1])
      {
        showMenu=true;
        showControls[1]=false;
        enter=false;
      } else if (showControls[0])
      { 
        showControls[1]=true;
        showControls[0]=false;
        enter=false;
      } else if (spoonPosY == 435)
      {
        showControls[0]=true;
        showMenu=false;
        enter=false;
      }

      if (spoonPosY == 545)
      {
        exit();
      }
    }

    if (menuTimer>15&&!showControls[0]&&!showControls[1]&&!showStory)
    {
      if (up && spoonPosY > 215) 
      {
        spoonPosY-=110;
        menuTimer=0;
      } else if (up && spoonPosY == 215)
      {
        spoonPosY=545;
        menuTimer=0;
      }

      if (down && spoonPosY < 545) 
      {
        spoonPosY+=110;
        menuTimer=0;
      } else if (down && spoonPosY == 545)
      {
        spoonPosY=215;
        menuTimer=0;
      }
    }
  }

  void keyPressed() 
  {
    if (keyCode == UP || key == 'w') 
    {
      up = true;
    }
    if (keyCode == DOWN || key == 's') 
    {
      down = true;
    }
    if (key == '\n' || key == ' ') 
    {
      enter = true;
    }
  }

  void keyReleased()
  {
    if (keyCode == UP || key == 'w') 
    {
      up = false;
    }
    if (keyCode == DOWN || key == 's') 
    {
      down = false;
    }
    if (key == '\n' || key == ' ') 
    {
      enter = false;
    }
  }
}
