class Player
{
  PImage spoonknight;
  PImage projectile;
  PImage[] walk = new PImage[5];
  PImage[] attack = new PImage[4];
  PImage[] swoosh = new PImage[2];
  PImage[] swooshUp = new PImage[2];
  PImage[] swooshDown = new PImage[2];
  PImage[] dash = new PImage[9];
  PImage[] damage = new PImage[2];
  PImage[] death = new PImage[2];
  PImage[] heal = new PImage[9];
  PImage[] shoot = new PImage[4];
  PImage[] projectileHit = new PImage[6];
  PImage[] projectileHitUp = new PImage[6];
  PImage[] projectileHitDown = new PImage[6];
  // Die Boolean Arrays sind immer gegen den Uhrzeigersinn geordnet (orientiert daran, dass w, a, s, d normalerweise für oben, links, unten, rechts steht)
  boolean wasd[] = new boolean[4];
  boolean intersects[] = new boolean[4];
  boolean intersectsObstacle[][] = new boolean[10][4];
  boolean arrows[] = new boolean[4];
  boolean attackAnimation[] = new boolean[4];
  boolean shootAnimation[] = new boolean[4];
  boolean dashDirection[] = new boolean[4];
  boolean blickR=true, spacebar, isDead, projectileIsShot, shift;
  int timeSinceAttack=100, timeSinceDash=100, timeSinceDamaged=100, attackFrameCounter=0, timeSinceDeath=0, timeSinceHeal=100, timeSinceShoot=100, timeSinceProjectileHit=100;
  int health=6, projectileDirection=100;
  int obstaclePosX[] = new int[7];
  int obstaclePosY[] = new int[7];
  float x, y, w=120, h=120, projectileX=900, projectileY=120;

  Player(float x, float y)
  {
    this.x=x;
    this.y=y;
    spoonknight= loadImage("Spoonknight/Spoonknight.png");
    walk[0]= loadImage("Spoonknight/SpoonknightWalkcycle0.png");
    walk[1]= loadImage("Spoonknight/SpoonknightWalkcycle1.png");
    walk[2]= loadImage("Spoonknight/SpoonknightWalkcycle2.png");
    walk[3]= loadImage("Spoonknight/SpoonknightWalkcycle3.png");
    walk[4]= loadImage("Spoonknight/SpoonknightWalkcycle4.png");
    attack[0]= loadImage("Spoonknight/SpoonknightAttack0.png");
    attack[1]= loadImage("Spoonknight/SpoonknightAttack1.png");
    attack[2]= loadImage("Spoonknight/SpoonknightAttack2.png");
    attack[3]= loadImage("Spoonknight/SpoonknightAttack3.png");
    swoosh[0]= loadImage("Spoonknight/AttackField0.png");
    swoosh[1]= loadImage("Spoonknight/AttackField1.png");
    swooshUp[0]= loadImage("Spoonknight/AttackFieldUp0.png");
    swooshUp[1]= loadImage("Spoonknight/AttackFieldUp1.png");
    swooshDown[0]= loadImage("Spoonknight/AttackFieldDown0.png");
    swooshDown[1]= loadImage("Spoonknight/AttackFieldDown1.png");
    for (int i=0; i<dash.length; i++)
    {
      dash[i]=loadImage("Spoonknight/SpoonknightDash"+i+".png");
    }
    damage[0]= loadImage("Spoonknight/SpoonknightDamaged0.png");
    damage[1]= loadImage("Spoonknight/SpoonknightDamaged1.png");
    death[0]= loadImage("Spoonknight/SpoonknightDead0.png");
    death[1]= loadImage("Spoonknight/SpoonknightDead1.png");
    for (int i=0; i<heal.length; i++)
    {
      heal[i]=loadImage("Spoonknight/SpoonknightHealing"+i+".png");
    }
    projectile= loadImage("Spoonknight/Projectile.png");
    for (int i=0; i<shoot.length; i++)
    {
      shoot[i]=loadImage("Spoonknight/SpoonknightShoot"+i+".png");
    }
    for (int i=0; i<projectileHit.length; i++)
    {
      projectileHit[i]=loadImage("Spoonknight/ProjectileHit"+i+".png");
      projectileHitUp[i]=loadImage("Spoonknight/ProjectileHitUp"+i+".png");
      projectileHitDown[i]=loadImage("Spoonknight/ProjectileHitDown"+i+".png");
    }
  }

  void update()
  {
    timer();
    move();
    attack();
    attackAnimation();
    intersects();
    dash();
    damageAnimation();
    deathAnimation();
    heal();
    shoot();
    shootAnimation();
    projectile();
  }

  //Verschiedene Timer für die Abklingzeiten des Spielers
  void timer()
  {
    timeSinceAttack++;
    timeSinceDash++;
    timeSinceDamaged++;
    timeSinceHeal++;
    timeSinceProjectileHit++;
  }

  //Durch die Schussfähigkeit abgefeuertes Projektil
  void projectile()
  {
    if (projectileIsShot)
    {
      image(projectile, projectileX, projectileY, w, h);
      switch(projectileDirection)
      {
      case 0:
        projectileY-=30;
        break;
      case 1:
        projectileX-=30;
        break;
      case 2:
        projectileY+=30;
        break;
      case 3:
        projectileX+=30;
        break;
      }
      for (int i=0; i<slimes.size(); i++)
      {
        if (projectileY-slimes.get(i).y>-60&&projectileY-slimes.get(i).y<60&&projectileX-slimes.get(i).x>-60&&projectileX-slimes.get(i).x<60)
        {
          slimes.get(i).getDamage(2);
          projectileIsShot=false;
          timeSinceProjectileHit=0;
        }
      }
      if (projectileX>1720||projectileX<80||projectileY>840||projectileY<120)
      {
        projectileIsShot=false;
        timeSinceProjectileHit=0;
      }
    }

    if (timeSinceProjectileHit<18)
    {
      switch(projectileDirection)
      {
      case 0:
        image(projectileHitUp[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      case 1:
        pushMatrix();
        scale(-1.0, 1.0);
        image(projectileHit[timeSinceProjectileHit/3], -projectileX-w, projectileY, w, h);
        popMatrix();
        break;
      case 2:
        image(projectileHitDown[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      case 3:
        image(projectileHit[timeSinceProjectileHit/3], projectileX, projectileY, w, h);
        break;
      }
    }
  }

  //Animation für den Schussangriff
  void shootAnimation()
  {
    if (shootAnimation[0])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(shoot[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(shoot[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        attackFrameCounter++;
      } else
      {
        shootAnimation[0]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[1])
    {
      if (attackFrameCounter<12)
      {
        pushMatrix();
        scale(-1.0, 1.0);
        image(shoot[attackFrameCounter/3], -x-w, y, w, h);
        popMatrix();
        attackFrameCounter++;
      } else
      {
        shootAnimation[1]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[2])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(shoot[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(shoot[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        attackFrameCounter++;
      } else
      {
        shootAnimation[2]=false;
        attackFrameCounter=0;
      }
    }
    if (shootAnimation[3])
    {
      if (attackFrameCounter<12)
      {
        image(shoot[attackFrameCounter/3], x, y, w, h);
        attackFrameCounter++;
      } else
      {
        shootAnimation[3]=false;
        attackFrameCounter=0;
      }
    }
  }
  
  //Schussangriff
  void shoot()
  {
    if (shift&&timeSinceAttack>60&&timeSinceDash>60&&health>0&&slimeCollected>=1)
    {
      for (int i=0; i<arrows.length; i++)
      {
        if (arrows[i])
        {
          timeSinceAttack=0;
          projectileX=x;
          projectileY=y;
          projectileIsShot=true;
          shootAnimation[i]=true;
          projectileDirection=i;
          slimeCollected--;
        }
      }
    }
  }
  
  //Heilungsfähigkeit mit Animation
  void heal()
  {
    if (health>0&&timeSinceDash>24&&timeSinceDamaged>30&&timeSinceAttack>12)
    {
      if (key=='e'&&slimeCollected>=10&&timeSinceHeal>=120&&health<6)
      {
        slimeCollected-=10;
        health+=2;
        if (health>6)
        {
          health=6;
        }
        timeSinceHeal=0;
      }

      if (timeSinceHeal<27)
      {
        if (blickR)
        {
          image(heal[timeSinceHeal/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(heal[timeSinceHeal/3], -x-w, y, w, h);
          popMatrix();
        }
      }
    }
  }

  //Animation die bei Tod des Spielers angezeigt wird
  void deathAnimation()
  {
    if (timeSinceDeath>=120)
    {
      isDead=true;
      timeSinceDeath=0;
    } else if (health<=0&&timeSinceDamaged>30)
    {
      image(death[timeSinceDeath/12%2], x, y, w, h);
      timeSinceDeath++;
    }
  }

  //Lebensverringerung und Rückstoss bei Gegnerkollision
  void takeDamage(int damageDirection)
  {
    if (timeSinceDash>24)
    {
      if (timeSinceDamaged>30&&health>0)
      {
        health--;
        timeSinceDamaged=0;
      } else
      {
        switch(damageDirection)
        {
        case 0:
          if (!intersects[2])
          {
            y+=20;
          } 
          break;

        case 1:
          if (!intersects[3])
          {
            x+=20;
          } 
          break;

        case 2:
          if (!intersects[0])
          {
            y-=20;
          } 
          break;

        case 3:
          if (!intersects[1])
          {
            x-=20;
          }
          break;
        }
      }
    }
  }
  
  //Animation bei Gegnerkollision
  void damageAnimation()
  {
    if (timeSinceDamaged<=30)
    {
      if (blickR)
      {
        image(damage[frameCount/3%2], x, y, w, h);
      } else
      {
        pushMatrix();
        scale(-1.0, 1.0);
        image(damage[frameCount/3%2], -x-w, y, w, h);
        popMatrix();
      }
    }
  }
  
  //Animation und rapide Fortbewegung bei Einsatz der Dash-Fähigkeit
  void dash()
  {
    if (timeSinceDash>180&&health>0)
    {
      if (spacebar)
      {
        timeSinceDash=0;
        if (wasd[0])
        {
          dashDirection[0]=true;
        } else if (wasd[1])
        {
          dashDirection[1]=true;
        } else if (wasd[2]==true)
        {
          dashDirection[2]=true;
        } else if (wasd[3])
        {
          dashDirection[3]=true;
        } else
        {
          if (!blickR)
          {
            dashDirection[1]=true;
          } else
          {
            dashDirection[3]=true;
          }
        }
      }
    }

    if (timeSinceDash<=24)
    {
      if (blickR)
      {
        image(dash[timeSinceDash/3], x, y, w, h);
      } else
      {
        pushMatrix();
        scale(-1.0, 1.0);
        image(dash[timeSinceDash/3], -x-w, y, w, h);
        popMatrix();
      }

      if (!intersects[0]) 
      {
        if (dashDirection[0])
        {
          y=y-15;
        }
      }
      if (!intersects[1])  
      {
        if (dashDirection[1])
        {
          x=x-15;
        }
      }
      if (!intersects[2]) 
      {
        if (dashDirection[2])
        {
          y=y+15;
        }
      }
      if (!intersects[3])  
      {
        if (dashDirection[3])
        {
          x=x+15;
        }
      }
    } else
    {
      dashDirection[0]=false;
      dashDirection[1]=false;
      dashDirection[2]=false;
      dashDirection[3]=false;
    }
  }

  //Animation des Angriffs
  void attackAnimation()
  {
    if (attackAnimation[0])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(attack[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(attack[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        image(swooshUp[attackFrameCounter/6], x, y-120, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[0]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[1])
    {
      if (attackFrameCounter<12)
      {
        pushMatrix();
        scale(-1.0, 1.0);
        image(attack[attackFrameCounter/3], -x-w, y, w, h);
        image(swoosh[attackFrameCounter/6], -x, y, w, h);
        popMatrix();
        attackFrameCounter++;
      } else
      {
        attackAnimation[1]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[2])
    {
      if (attackFrameCounter<12)
      {
        if (blickR)
        {
          image(attack[attackFrameCounter/3], x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(attack[attackFrameCounter/3], -x-w, y, w, h);
          popMatrix();
        }
        image(swooshDown[attackFrameCounter/6], x, y+120, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[2]=false;
        attackFrameCounter=0;
      }
    }
    if (attackAnimation[3])
    {
      if (attackFrameCounter<12)
      {
        image(attack[attackFrameCounter/3], x, y, w, h);
        image(swoosh[attackFrameCounter/6], x+120, y, w, h);
        attackFrameCounter++;
      } else
      {
        attackAnimation[3]=false;
        attackFrameCounter=0;
      }
    }
  }

  //Angriff der Gegnern bei Treffer Schaden zufügt
  void attack()
  {
    if (!shift&&timeSinceAttack>60&&timeSinceDash>60&&health>0)
    {
      if (arrows[0])
      {
        attackAnimation[0]=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (y-120-slimes.get(i).y>-90&&y-120-slimes.get(i).y<90&&x-slimes.get(i).x>-90&&x-slimes.get(i).x<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[1])
      {
        attackAnimation[1]=true;
        blickR=false;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (x-120-slimes.get(i).x>-90&&x-120-slimes.get(i).x<90&&y-slimes.get(i).y>-90&&y-slimes.get(i).y<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[2])
      {
        attackAnimation[2]=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (y+120-slimes.get(i).y>-90&&y+120-slimes.get(i).y<90&&x-slimes.get(i).x>-90&&x-slimes.get(i).x<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      } else if (arrows[3])
      {
        attackAnimation[3]=true;
        blickR=true;
        timeSinceAttack=0;
        for (int i=0; i<slimes.size(); i++)
        {
          if (x+120-slimes.get(i).x>-90&&x+120-slimes.get(i).x<90&&y-slimes.get(i).y>-90&&y-slimes.get(i).y<90)
          {
            slimes.get(i).getDamage(1);
          }
        }
      }
    }
  }
  
  //Prüft auf Kollisionen
  void intersects()
  {
    int obstacleCounter=0;
    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (map.obstacleGrid[i][j]!=0)
        {
          obstaclePosX[obstacleCounter]=(i+2)*120;
          obstaclePosY[obstacleCounter]=(j+2)*120;
          obstacleCounter++;
        }
      }
    }

    for (int i=0; i<obstacleCounter; i++)
    {
      if (y-obstaclePosY[i]<=75&&y-obstaclePosY[i]>0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][0]=true;
      } else
      {
        intersectsObstacle[i][0]=false;
      }

      if (x-obstaclePosX[i]<=105&&x-obstaclePosX[i]>0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][1]=true;
      } else
      {
        intersectsObstacle[i][1]=false;
      }

      if (y-obstaclePosY[i]>=-120 &&y-obstaclePosY[i]<0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][2]=true;
      } else
      {
        intersectsObstacle[i][2]=false;
      }

      if (x-obstaclePosX[i]>=-105 &&x-obstaclePosX[i]<0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][3]=true;
      } else
      {
        intersectsObstacle[i][3]=false;
      }
    }

    for (int i=0; i<4; i++)
    {
      if (intersectsObstacle[0][i]||intersectsObstacle[1][i]||intersectsObstacle[2][i]||intersectsObstacle[3][i]||intersectsObstacle[4][i]||intersectsObstacle[5][i]||intersectsObstacle[6][i])
      {
        intersects[i]=true;
      } else
      {
        intersects[i]=false;
      }
    }
    if (y <= 120) 
    {
      intersects[0] = true;
    } 
    
    if (x <= 105) 
    {
      intersects[1] = true;
    }

    if (y >= 840) 
    {
      intersects[2] = true;
    } 

    if (x >= 1695) 
    {
      intersects[3] = true;
    }
  }

  //Bewegung des Spielers durch wasd mit Animation
  void move()
  {
    if (timeSinceAttack>=12&&timeSinceDash>24&&timeSinceHeal>=27)
    {
      if (!intersects[0]) 
      {
        if (wasd[0]==true)
        {
          y=y-5;
        }
      }
      if (!intersects[1])  
      {
        if (wasd[1]==true)
        {
          x=x-5;
          blickR=false;
        }
      }
      if (!intersects[2]) 
      {
        if (wasd[2]==true)
        {
          y=y+5;
        }
      }
      if (!intersects[3])  
      {
        if (wasd[3]==true)
        {
          x=x+5;
          blickR=true;
        }
      }

      if (timeSinceDamaged>30)
      {
        if (wasd[0]==true||wasd[1]==true||wasd[2]==true||wasd[3]==true)
        {
          if (blickR)
          {
            image(walk[frameCount/6%5], x, y, w, h);
          } else
          {
            pushMatrix();
            scale(-1.0, 1.0);
            image(walk[frameCount/6%5], -x-w, y, w, h);
            popMatrix();
          }
        } else if (blickR)
        {
          image(spoonknight, x, y, w, h);
        } else
        {
          pushMatrix();
          scale(-1.0, 1.0);
          image(spoonknight, -x-w, y, w, h);
          popMatrix();
        }
      }
    }
  }

  void keyPressed()
  {
    if (health>0&&timeSinceHeal>=27)
    {
      if (key =='w')
      {
        wasd[0]=true;
      }
      if (key =='a')
      {
        wasd[1]=true;
      }
      if (key =='s')
      {
        wasd[2]=true;
      }
      if (key =='d')
      {
        wasd[3]=true;
      }
      if (key ==' ')
      {
        spacebar=true;
      }
      if (keyCode == UP)
      {
        arrows[0]=true;
      }
      if (keyCode == LEFT)
      {
        arrows[1]=true;
      }
      if (keyCode == DOWN)
      {
        arrows[2]=true;
      }
      if (keyCode == RIGHT)
      {
        arrows[3]=true;
      }
      if (keyCode == SHIFT)
      {
        shift=true;
      }
    }
  }

  void keyReleased()
  {
    if (key =='w')
    {
      wasd[0]=false;
    }
    if (key =='a')
    {
      wasd[1]=false;
    }
    if (key =='s')
    {
      wasd[2]=false;
    }
    if (key =='d')
    {
      wasd[3]=false;
    }
    if (key ==' ')
    {
      spacebar=false;
    }
    if (keyCode == UP)
    {
      arrows[0]=false;
    }
    if (keyCode == LEFT)
    {
      arrows[1]=false;
    }
    if (keyCode == DOWN)
    {
      arrows[2]=false;
    }
    if (keyCode == RIGHT)
    {
      arrows[3]=false;
    }
    if (keyCode == SHIFT)
    {
      shift=false;
    }
  }
}
