class Slime
{
  PImage[] death = new PImage[6];
  PImage[] jump = new PImage[8];
  PImage[] damage = new PImage[2];
  boolean intersects[] = new boolean[4];
  boolean intersectsObstacle[][] = new boolean[7][4];
  boolean isDead, small;
  int direction, timeSinceDamaged=100, timeSinceDeath=0, health=4, jumpDelay, directionRandomizer, frameCounter=24;
  int obstaclePosX[] = new int[7];
  int obstaclePosY[] = new int[7];
  float x, y, w=120, h=120, hitboxReduction=0, distancePlayerX, distancePlayerY;
  char slimeColor;
  String size = "";

  Slime(float x, float y, char slimeColor, boolean small)
  {
    this.x=x;
    this.y=y;
    this.slimeColor=slimeColor;
    this.small = small;

    if (small)
    {
      health=2;
      hitboxReduction=15;
      size="Small";
    }

    for (int i=0; i<jump.length; i++)
    {
      jump[i]=loadImage("Enemies/"+slimeColor+size+"SlimeJump"+i+".png");
    }
    damage[0]= loadImage("Enemies/"+slimeColor+size+"SlimeDamaged0.png");
    damage[1]= loadImage("Enemies/"+slimeColor+size+"SlimeDamaged1.png");
    for (int i=0; i<death.length; i++)
    {
      death[i]=loadImage("Enemies/"+slimeColor+size+"SlimeDead"+i+".png");
    }

    //Die verschiedenen Slimefarben sollen sich in unterschiedlicher Frequenz bewegen
    switch(slimeColor)
    {
    case 'g':
      jumpDelay=144;
      break;
    case 'y':
      jumpDelay=96;
      break;
    case 'r':
      jumpDelay=48;
      break;
    }
  }

  void update()
  {
    intersects();
    move();
    applyDamage();
    death();
    damageAnimation();
    timeSinceDamaged++;
    frameCounter++;
  }

  //Regelmäßige Fortbewegung des Slimes mit Sprunganimation
  void move()
  {
    if (health>0||x%120!=0||y%120!=0)
    {
      if (timeSinceDamaged>30)
      {
        image(jump[frameCounter/6%8], x, y, w, h);
      }

      directionCalculation();

      if (frameCounter%jumpDelay<24)
      {
        switch(direction)
        {
        case 0:
          y=y-5;
          break;
        case 1: 
          x=x-5;
          break;
        case 2: 
          y=y+5;
          break;
        case 3: 
          x=x+5;
          break;
        case 4:
        }
      }
    }
  }

  //Kalkulation der nächsten Bewegung (Zu 70% Bewegung in Richtung des Spielers, zu 20% Bewegung in zufällige Richtung, zu 10% ausharren auf momentaner Position) 
  void  directionCalculation()
  {
    if (frameCounter%jumpDelay==0)
    {
      distancePlayerX=player.x-x;
      distancePlayerY=player.y-y;
      directionRandomizer=(int)random(0, 10);

      if (directionRandomizer<7)
      {
        if (Math.abs(distancePlayerX)<Math.abs(distancePlayerY))
        {
          if (distancePlayerY<0&&!intersects[0])
          {
            direction=0;
          } else if (distancePlayerY>0&&!intersects[2])
          {
            direction=2;
          } else if (distancePlayerX<0&&!intersects[1])
          {
            direction=1;
          } else if (distancePlayerX>0&&!intersects[3])
          {
            direction=3;
          } else
          {
            direction=4;
          }
        } else
        {
          if (distancePlayerX<0&&!intersects[1])
          {
            direction=1;
          } else if (distancePlayerX>0&&!intersects[3])
          {
            direction=3;
          } else if (distancePlayerY<0&&!intersects[0])
          {
            direction=0;
          } else if (distancePlayerY>0&&!intersects[2])
          {
            direction=2;
          } else
          {
            direction=4;
          }
        }
      } else if (directionRandomizer<9)
      {
        do
        {
          direction=(int)random(0, 4);
        }
        while (intersects[direction]);
      } else if (directionRandomizer==9)
      {
        direction=4;
      }
    }
  }

  //Lässt den Slime mit Animation verschwinden wenn er keine Lebenspunkte mehr hat und teilt große Slimes in 2 kleine Slimes auf
  void death()
  {
    if (health<=0&&timeSinceDamaged>30)
    {
      image(death[timeSinceDeath/6], x, y, w, h);
      timeSinceDeath++;
    }

    if (timeSinceDeath==10&&!small)
    {
      slimes.add(new Slime(x, y, slimeColor, true));
      slimes.add(new Slime(x, y, slimeColor, true));
    }

    if (timeSinceDeath>=33)
    {
      isDead=true;
    }
  }

  //Animation bei Schaden
  void damageAnimation()
  {
    if (health>=0)
    {
      if (timeSinceDamaged<30)
      {
        image(damage[frameCounter/6%2], x, y, w, h);
      }
    }
  }

  //Schaden bei Attackentreffer durch Spieler
  void getDamage(int damage)
  {
    health-=damage;
    timeSinceDamaged=0;
  }

  //Fügt Spieler bei Berührung Schaden zu
  void applyDamage()
  {
    if (y-player.y>=-60&&y-player.y<0&&x-player.x>=-60&&x-player.x<=60)
    {
      player.takeDamage(0);
    }
    if (x-player.x>=-90+hitboxReduction&&x-player.x<0&&y-player.y>=-60&&y-player.y<=60)
    {
      player.takeDamage(1);
    }
    if (y-player.y<=90-hitboxReduction&&y-player.y>0&&x-player.x>=-60&&x-player.x<=60)
    {
      player.takeDamage(2);
    }
    if (x-player.x<=90-hitboxReduction&&x-player.x>0&&y-player.y>=-60&&y-player.y<=60)
    {
      player.takeDamage(3);
    }
  }

  //Prüft auf Kollisionen
  void intersects()
  {
    int obstacleCounter=0;
    for (int i=0; i<12; i++)
    {
      for (int j=0; j<5; j++)
      {
        if (map.obstacleGrid[i][j]!=0)
        {
          obstaclePosX[obstacleCounter]=(i+2)*120;
          obstaclePosY[obstacleCounter]=(j+2)*120;
          obstacleCounter++;
        }
      }
    }

    for (int i=0; i<obstacleCounter; i++)
    {
      if (y-obstaclePosY[i]<=120&&y-obstaclePosY[i]>0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][0]=true;
      } else
      {
        intersectsObstacle[i][0]=false;
      }

      if (x-obstaclePosX[i]<=120&&x-obstaclePosX[i]>0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][1]=true;
      } else
      {
        intersectsObstacle[i][1]=false;
      }

      if (y-obstaclePosY[i]>=-120 &&y-obstaclePosY[i]<0 && x>=obstaclePosX[i]-90&&x<=obstaclePosX[i]+90)
      {
        intersectsObstacle[i][2]=true;
      } else
      {
        intersectsObstacle[i][2]=false;
      }

      if (x-obstaclePosX[i]>=-120 &&x-obstaclePosX[i]<0 && y>=obstaclePosY[i]-105&&y<=obstaclePosY[i]+60)
      {
        intersectsObstacle[i][3]=true;
      } else
      {
        intersectsObstacle[i][3]=false;
      }
    }

    for (int i=0; i<4; i++)
    {
      if (intersectsObstacle[0][i]||intersectsObstacle[1][i]||intersectsObstacle[2][i]||intersectsObstacle[3][i]||intersectsObstacle[4][i]||intersectsObstacle[5][i]||intersectsObstacle[6][i])
      {
        intersects[i]=true;
      } else
      {
        intersects[i]=false;
      }
    }
    if (y <= 120) 
    {
      intersects[0] = true;
    } 
    if (x <= 120) 
    {
      intersects[1] = true;
    }

    if (y >= 840) 
    {
      intersects[2] = true;
    } 

    if (x >= 1680) 
    {
      intersects[3] = true;
    }
  }
}
